Tp::Service::ConnectionInterfaceAddressingAdaptor Class Reference

| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | List of all members
Tp::Service::ConnectionInterfaceAddressingAdaptor Class Reference
Connection service implementation

`#include <TelepathyQt/_gen/svc-connection.h>`

Inherits Tp::AbstractAdaptor.

## Public Slots
Tp::AddressingNormalizationMap | GetContactsByVCardField (const QString &field, const QStringList &addresses, const QStringList &interfaces, const QDBusMessage &dbusMessage, Tp::ContactAttributesMap &attributes)
Tp::AddressingNormalizationMap | GetContactsByURI (const QStringList &URIs, const QStringList &interfaces, const QDBusMessage &dbusMessage, Tp::ContactAttributesMap &attributes)

## Additional Inherited Members
Public Member Functions inherited from Tp::AbstractAdaptor
| AbstractAdaptor (const QDBusConnection &connection, QObject *adaptee, QObject *parent)
| ~AbstractAdaptor ()
QDBusConnection | dbusConnection () const
QObject * | adaptee () const

## Detailed Description

Adaptor class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Connection.Interface.Addressing1".

## Member Function Documentation

Tp::AddressingNormalizationMap Tp::Service::ConnectionInterfaceAddressingAdaptor::GetContactsByVCardField | ( | const QString & | field,
|  | const QStringList & | addresses,
|  | const QStringList & | interfaces,
|  | const QDBusMessage & | dbusMessage,
|  | Tp::ContactAttributesMap & | attributes
| ) |  |
| slot

Begins a call to the exported D-Bus method `GetContactsByVCardField` on this object.

Adaptees should export this method as a Qt slot with the following signature: void getContactsByVCardField(const QString& field, const QStringList& addresses, const QStringList& interfaces, const Tp::Service::ConnectionInterfaceAddressingAdaptor::GetContactsByVCardFieldContextPtr &context);

Implementations should call MethodInvocationContext::setFinished (or setFinishedWithError accordingly) on the received context object once the method has finished processing.

Request contacts and retrieve their attributes using a given field in their vCards.

The connection manager should record that these handles are in use by the client who invokes this method, and must not deallocate the handles until the client disconnects from the bus or calls the ConnectionInterface::ReleaseHandles() method.

Parameters

  field | The vCard field of the addresses we are requesting. The field name SHOULD be in lower case. Supported fields can be found in \\\ \\link ProtocolInterfaceAddressingInterface::requestPropertyAddressableVCardFields() ProtocolInterfaceAddressingInterface::AddressableVCardFields \\endlink \\htmlonly .

The `url` vCard field MUST NOT appear here; see \\endhtmlonly GetContactsByURI() \\htmlonly instead.

In practice, protocols have a limited set of URI schemes that make sense to resolve as a contact.

Parameters

  addresses |
      The addresses to get contact handles for. The address types should
      match the given vCard field.
  interfaces | A list of strings indicating which D-Bus interfaces the calling process is interested in. All supported attributes from these interfaces, whose values can be obtained without additional network activity, will be in the reply. Attributes from this interface and from \\\ ConnectionInterface \\htmlonly are always returned, and need not be requested explicitly.

The behavior of this parameter is similar to the same parameter in \\endhtmlonly ConnectionInterfaceContactsInterface::GetContactAttributes() \\htmlonly .

Parameters

  attributes | Output parameter

A dictionary mapping the contact handles to contact attributes. If any of the requested addresses are in fact invalid, they are simply omitted from this mapping. If contact attributes are not immediately known, the behaviour is defined by the interface; the attribute should either be omitted from the result or replaced with a default value.

Requested addresses that are not valid or understood for this protocol MUST be omitted from the mapping.

Each contact's attributes will always include at least the identifier that would be obtained by inspecting the handle (`org.freedesktop.Telepathy.Connection/contact-id`).

Returns

A mapping from requested vCard addresses to the corresponding contact handles.

Requested addresses that are not valid or understood for this protocol MUST be omitted from the mapping.

Tp::AddressingNormalizationMap Tp::Service::ConnectionInterfaceAddressingAdaptor::GetContactsByURI | ( | const QStringList & | URIs,
|  | const QStringList & | interfaces,
|  | const QDBusMessage & | dbusMessage,
|  | Tp::ContactAttributesMap & | attributes
| ) |  |
| slot

Begins a call to the exported D-Bus method `GetContactsByURI` on this object.

Adaptees should export this method as a Qt slot with the following signature: void getContactsByURI(const QStringList& URIs, const QStringList& interfaces, const Tp::Service::ConnectionInterfaceAddressingAdaptor::GetContactsByURIContextPtr &context);

Implementations should call MethodInvocationContext::setFinished (or setFinishedWithError accordingly) on the received context object once the method has finished processing.

Request contacts and retrieve their attributes using URI addresses.

The connection manager should record that these handles are in use by the client who invokes this method, and must not deallocate the handles until the client disconnects from the bus or calls the ConnectionInterface::ReleaseHandles() method.

Parameters

  URIs |
      The URI addresses to get contact handles for. Supported schemes can
      be found in AddressableURISchemes.
  interfaces | A list of strings indicating which D-Bus interfaces the calling process is interested in. All supported attributes from these interfaces, whose values can be obtained without additional network activity, will be in the reply. Attributes from this interface and from \\\ ConnectionInterface \\htmlonly are always returned, and need not be requested explicitly.

The behavior of this parameter is similar to the same parameter in \\endhtmlonly ConnectionInterfaceContactsInterface::GetContactAttributes() \\htmlonly .

Parameters

  attributes | Output parameter

A dictionary mapping the contact handles to contact attributes. If any of the requested addresses are in fact invalid, they are simply omitted from this mapping. If contact attributes are not immediately known, the behaviour is defined by the interface; the attribute should either be omitted from the result or replaced with a default value.

Requested URIs that are not valid or understood for this protocol MUST be omitted from the mapping.

Each contact's attributes will always include at least the identifier that would be obtained by inspecting the handle (`org.freedesktop.Telepathy.Connection/contact-id`).

Returns

A mapping of requested URIs to the corresponding contact handles.

Requested URIs that are not valid or understood for this protocol MUST be omitted from the mapping.